#include <stdio.h>

int main(int argc, char **argv)
{
  int i[2];  /* Now i is eight bytes on the stack, or two integers. */
  int *j;

  /* Set up values in the array and print it. */
  i[0] = 1;
  i[1] = 2;
  printf("i[0]=%d i[1]=%d\n", i[0], i[1]);

  /* Let j point to the first element of the array.  Naturally, *j
   * is the value of i[0].  It is also possible to do arithmetic with
   * pointers---j is the address of i[0], and j+1 is the address of the
   * next integer in memory, which happens to be i[1].  Note that if
   * j is an int *, j+1 is an address four bytes higher, but if j is a
   * char *, for example, j+1 is an address one byte higher.  In general,
   * pointer arithmetic is based on the width of the type pointed to.
   */
  j = &i[0];
  printf("  j=%p     *j=%d\n", j, *j);
  printf("j+1=%p *(j+1)=%d\n", j + 1, *(j + 1));

  /* Set the first element of the array indirectly. */
  *j = 3;
  printf("i[0]=%d i[1]=%d\n", i[0], i[1]);

  /* Use pointer arithmetic again to change the second element. */
  *(j + 1) = 4;
  printf("i[0]=%d i[1]=%d\n", i[0], i[1]);

  return 0;
}
