#include <stdio.h>

/* This example is the exact same program as array.c, but introduces
 * different syntax. */
int main(int argc, char **argv)
{
  int i[2];
  int *j;

  i[0] = 1;
  i[1] = 2;
  printf("i[0]=%d i[1]=%d\n", i[0], i[1]);

  /* The name of an array is the same as the address of its first element,
   * so j = i is equivalent to j = &i[0].  Furthermore, you can use array
   * syntax with pointers, so j[0] is the same as *j; j[0] is the same
   * as *(j+1).
   */
  j = i;
  printf("    j=%p j[0]=%d\n", j, j[0]);
  printf("&j[1]=%p j[1]=%d\n", &j[1], j[1]);

  j[0] = 3;
  printf("i[0]=%d i[1]=%d\n", i[0], i[1]);

  j[1] = 4;
  printf("i[0]=%d i[1]=%d\n", i[0], i[1]);

  return 0;
}
