#include <stdio.h>
#include <stdlib.h>

/* This is exactly the same as linked.c, but now we define all the helper
 * functions in another file, linked2.h, and #include it.  Using double
 * quotes instead of angle brackets causes the preprocessor to look
 * locally rather than in system library locations.
 */
#include "linked2.h"

int main(int argc, char **argv)
{
  list *l = NULL;
  list *tmp = NULL;
  int i;

  for (i = 0; i < 10; ++i)
  {
    tmp = (list *) malloc(sizeof(list));
    if (tmp == NULL)
    {
      fprintf(stderr, "Could not allocate memory for element.\n");
      exit(1);
    }

    make_list(tmp, i);
    if (l == NULL)
      l = tmp;
    else
      insert_list(l, tmp);
  }

  tmp = l;
  do
  {
    printf("%d\n", tmp->data);
    tmp = tmp->next;
  } while (tmp != l);

  free_list(l);
  return 0;
}
